VERSION 5.00
Begin VB.Form frmMergeSort 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "MergeSort"
   ClientHeight    =   9435
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9435
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.OptionButton Option2 
      Caption         =   "QuickSort"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   9120
      Width           =   1215
   End
   Begin VB.OptionButton Option1 
      Caption         =   "MergeSort"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   8760
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.ListBox List2 
      Height          =   6495
      Left            =   2400
      TabIndex        =   3
      Top             =   2160
      Width           =   2175
   End
   Begin VB.ListBox List1 
      Height          =   6495
      Left            =   120
      TabIndex        =   2
      Top             =   2160
      Width           =   2175
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Sortieren"
      Height          =   375
      Left            =   1680
      TabIndex        =   1
      Top             =   8880
      Width           =   1455
   End
   Begin VB.PictureBox Picture1 
      Height          =   1815
      Left            =   120
      ScaleHeight     =   1755
      ScaleWidth      =   4395
      TabIndex        =   0
      Top             =   240
      Width           =   4455
   End
End
Attribute VB_Name = "frmMergeSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const Num As Long = 200, Max As Long = 100

Private Declare Sub Sleep Lib "kernel32" (ByVal X As Long)

Private Sub Command1_Click()
   Dim MyArray(Num) As Long, i As Long
   
   Command1.Enabled = False
   Option1.Enabled = False
   Option2.Enabled = False
   
   Call Randomize
   
   Call List1.Clear
   Call List2.Clear
   
   For i = 0 To Num
      MyArray(i) = Int(Rnd * (Max + 1))
      Call List1.AddItem(MyArray(i))
   Next i
   
   If Option1.Value = True Then
      Call MergeSort.MergeSort(MyArray)
   Else
      Call QuickSort.QuickSort(MyArray)
   End If
   
   For i = 0 To Num
      Call List2.AddItem(MyArray(i))
   Next i
   
   Command1.Enabled = True
   Option1.Enabled = True
   Option2.Enabled = True
End Sub

Private Sub Form_Load()
   Picture1.AutoRedraw = True
   Picture1.Scale (0, Max)-(Num, 0)
   Picture1.BackColor = vbWhite
   Picture1.DrawWidth = 2
End Sub

Public Sub Visualize(ByRef Data() As Long, Sorted As Long)
   Dim i As Long
   
   Call Picture1.Cls
   For i = 0 To Num
      Picture1.PSet (i, Data(i)), IIf(i > Sorted, vbRed, vbBlack)
   Next i
   Call [DoEvents]
   Call Sleep(15)
End Sub

Private Sub Option1_Click()
   Caption = IIf(Option1.Value = True, "MergeSort", "QuickSort")
End Sub

Private Sub Option2_Click()
   Call Option1_Click
End Sub
