Attribute VB_Name = "MergeSort"
Option Explicit

' Verschmilzt [Left; Middle] mit (Middle; Right] in [Left; Right]
Public Sub InplaceMerge(ByVal Left As Long, ByVal Middle As Long, ByVal Right As Long, ByRef Data() As Long)
   Dim Temp()  As Long
   Dim i       As Long
   Dim j       As Long
   Dim dst     As Long
   
   ' Temporres Array dimensionieren
   ReDim Temp(Middle - Left) As Long
   
   ' [Left; Middle] in das temporre Array kopieren
   j = 0
   For i = Left To Middle
      Temp(j) = Data(i)
      j = j + 1
   Next i
   
   ' Sortiert in das Originalarray zurckkopieren
   j = 0
   dst = Left
   Do While i <= Right And j <= UBound(Temp)
      If Data(i) < Temp(j) Then
         Data(dst) = Data(i)
         i = i + 1
      Else
         Data(dst) = Temp(j)
         j = j + 1
      End If
      dst = dst + 1
   Loop
   
   ' Ggf. das temporre Array ins Original schreiben, wenn noch etwas brig ist
   Do While j <= UBound(Temp)
      Data(dst) = Temp(j)
      dst = dst + 1
      j = j + 1
   Loop
End Sub

' Rekursiver Aufruf von MergeSort
Public Sub MergeSortRec(ByVal Left As Long, ByVal Right As Long, ByRef Data() As Long)
   Dim Middle As Long
   
   Middle = (Left + Right) \ 2
   
   If Left < Right Then
      Call MergeSortRec(Left, Middle, Data)
      Call MergeSortRec(Middle + 1, Right, Data)
      
      Call InplaceMerge(Left, Middle, Right, Data)
      
      Call frmMergeSort.Visualize(Data, Right)
   End If

End Sub

' Array-Wrapper-Aufruf fr MergeSortRec
Public Sub MergeSort(ByRef Data() As Long)
   Call MergeSortRec(0, UBound(Data), Data)
End Sub
