Attribute VB_Name = "QuickSort"
Option Explicit

' Rekursives QuickSort mit erstem Element als Pivotelement
Public Sub QuickSortRec(ByVal Left As Long, ByVal Right As Long, ByRef Data() As Long)
   Dim Pivot As Long, r As Long, l As Long, t As Long
   
   If Left >= Right Then Exit Sub
   
   Pivot = Data(Left)
   r = Right
   l = Left
   
   Do
      Do While Data(l) < Pivot
         l = l + 1
      Loop
      Do While Pivot < Data(r)
         r = r - 1
      Loop
      
      If l <= r Then
         t = Data(l)
         Data(l) = Data(r)
         Data(r) = t
         l = l + 1
         r = r - 1
      End If
            
   Loop Until l > r
   
   Call frmMergeSort.Visualize(Data, Right)
   
   Call QuickSortRec(Left, r, Data)
   Call QuickSortRec(l, Right, Data)
   
End Sub

' Array-Wrapper-Aufruf fr QuickSortRec
Public Sub QuickSort(ByRef Data() As Long)
   Call QuickSortRec(0, UBound(Data), Data)
End Sub
